/**
 *  \file IMP/base.h
 *  \brief A container which has pairs which ensure a set is connected
 *
 *  Copyright 2007-2014 IMP Inventors. All rights reserved.
 */

#ifndef IMP_BASE_H
#define IMP_BASE_H
#include <IMP/base/Array.h>
#include <IMP/base/ConstVector.h>
#include <IMP/base/CreateLogContext.h>
#include <IMP/base/Flag.h>
#include <IMP/base/Index.h>
#include <IMP/base/InputAdaptor.h>
#include <IMP/base/NonCopyable.h>
#include <IMP/base/Object.h>
#include <IMP/base/Pointer.h>
#include <IMP/base/RAII.h>
#include <IMP/base/SetCheckState.h>
#include <IMP/base/SetLogState.h>
#include <IMP/base/Showable.h>
#include <IMP/base/Value.h>
#include <IMP/base/Vector.h>
#include <IMP/base/VersionInfo.h>
#include <IMP/base/WarningContext.h>
#include <IMP/base/WeakPointer.h>
#include <IMP/base/base_macros.h>
#include <IMP/base/bracket_macros.h>
#include <IMP/base/cache.h>
#include <IMP/base/check_macros.h>
#include <IMP/base/comparison_macros.h>
#include <IMP/base/compiler_macros.h>
#include <IMP/base/deprecation.h>
#include <IMP/base/deprecation_macros.h>
#include <IMP/base/doxygen_macros.h>
#include <IMP/base/enums.h>
#include <IMP/base/exception.h>
#include <IMP/base/file.h>
#include <IMP/base/flags.h>
#include <IMP/base/graph_macros.h>
#include <IMP/base/hash.h>
#include <IMP/base/hash_macros.h>
#include <IMP/base/live_objects.h>
#include <IMP/base/log.h>
#include <IMP/base/log_macros.h>
#include <IMP/base/map.h>
#include <IMP/base/math.h>
#include <IMP/base/nullptr.h>
#include <IMP/base/nullptr_macros.h>
#include <IMP/base/object_cast.h>
#include <IMP/base/object_macros.h>
#include <IMP/base/piecewise_linear_distribution.h>
#include <IMP/base/raii_macros.h>
#include <IMP/base/random.h>
#include <IMP/base/ref_counted_macros.h>
#include <IMP/base/set.h>
#include <IMP/base/set_map_macros.h>
#include <IMP/base/showable_macros.h>
#include <IMP/base/statistics.h>
#include <IMP/base/swap_macros.h>
#include <IMP/base/swig_macros.h>
#include <IMP/base/thread_macros.h>
#include <IMP/base/threads.h>
#include <IMP/base/tuple_macros.h>
#include <IMP/base/types.h>
#include <IMP/base/utility.h>
#include <IMP/base/utility_macros.h>
#include <IMP/base/value_macros.h>
#include <IMP/base/vector_property_map.h>
#include <IMP/base/warning_macros.h>
#endif /* IMP_BASE_H */