/**
 *  \file IMP/container/EventPairsOptimizerState.h
 *  \brief Define some predicates.
 *
 *  WARNING This file was generated from EventPairsOptimizerState.h
 *  in /builddir/build/BUILD/imp-2.2.0/imp/tools/build/container_templates/container
 *  by tools/maintenance/setup_containers.py.
 *
 *  Copyright 2007-2014 IMP Inventors. All rights reserved.
 */

#ifndef IMPCONTAINER_EVENT_PAIRS_OPTIMIZER_STATE_H
#define IMPCONTAINER_EVENT_PAIRS_OPTIMIZER_STATE_H

#include <IMP/container/container_config.h>
#include <IMP/PairPredicate.h>
#include <IMP/OptimizerState.h>
#include <IMP/PairContainer.h>

IMPCONTAINER_BEGIN_NAMESPACE

/** Raise an IMP::base::EventException when a certain condition is met.
    Currently the supported logic is when the number of items in the
    container for which the predicate returns a certain value is in the
    range [min_count, max_count).
 */
class IMPCONTAINEREXPORT EventPairsOptimizerState : public OptimizerState {
  IMP::base::PointerMember<PairPredicate> pred_;
  IMP::base::PointerMember<PairContainer> container_;
  int v_;
  int min_, max_;

 public:
  EventPairsOptimizerState(PairPredicate *pred,
                                PairContainerAdaptor container, int value,
                                int min_count, int max_count,
                                std::string name =
                                    "ConstPairPredicate%1%");
  virtual void update() IMP_OVERRIDE;
  IMP_OBJECT_METHODS(EventPairsOptimizerState);
};

IMPCONTAINER_END_NAMESPACE

#endif /* IMPCONTAINER_EVENT_PAIRS_OPTIMIZER_STATE_H */
