/**
 *  \file IMP/container/InContainerTripletFilter.h
 *  \brief A filter for Triplets.
 *
 *  This file is generated by a script (core/tools/make-containers).
 *  Do not edit directly.
 *
 *  Copyright 2007-2014 IMP Inventors. All rights reserved.
 */

#ifndef IMPCONTAINER_IN_CONTAINER_TRIPLET_FILTER_H
#define IMPCONTAINER_IN_CONTAINER_TRIPLET_FILTER_H

#include <IMP/container/container_config.h>
#include <IMP/TripletPredicate.h>
#include <IMP/TripletContainer.h>
#include <IMP/kernel/internal/container_helpers.h>
#include "internal/TripletContainerIndex.h"
#include <IMP/triplet_macros.h>
#include <IMP/base/object_macros.h>
#include <IMP/base/warning_macros.h>

IMPCONTAINER_BEGIN_NAMESPACE

//! A filter which returns true if a container containers the Triplet
/** This predicate returns 1 if the passed tuple is in the container.
    \note Use the handle_permutations parameter to the constructor to
    determine whether only exact matchers, or matches under permutation
    are considered matching. By default they are are.
 */
class IMPCONTAINEREXPORT InContainerTripletFilter
    : public TripletPredicate {
  IMP::base::PointerMember<internal::TripletContainerIndex> c_;

 public:
  InContainerTripletFilter(TripletContainer *c,
                             std::string name = "TripletFilter %1%");
  InContainerTripletFilter(TripletContainer *c, bool handle_permutations,
                             std::string name = "TripletFilter %1%");

  virtual int get_value_index(kernel::Model *, const kernel::ParticleIndexTriplet& vt) const
      IMP_OVERRIDE {
    return c_->get_contains(vt);
  }
  virtual kernel::ModelObjectsTemp do_get_inputs(
      kernel::Model *m, const kernel::ParticleIndexes &pi) const IMP_OVERRIDE {
    kernel::ModelObjectsTemp ret = IMP::get_particles(m, pi);
    ret.push_back(c_);
    return ret;
  }
  IMP_TRIPLET_PREDICATE_METHODS(InContainerTripletFilter);
  IMP_OBJECT_METHODS(InContainerTripletFilter);
};

IMP_OBJECTS(InContainerTripletFilter, InContainerTripletFilters);

IMPCONTAINER_END_NAMESPACE

#endif /* IMPCONTAINER_IN_CONTAINER_TRIPLET_FILTER_H */
