/**
 *  \file IMP/container/ListTripletContainer.h
 *  \brief Store a list of kernel::ParticleTripletsTemp
 *
 *  WARNING This file was generated from ListTripletContainer.h
 *  in /builddir/build/BUILD/imp-2.2.0/imp/tools/build/container_templates/container
 *  by tools/maintenance/setup_containers.py.
 *
 *  Copyright 2007-2014 IMP Inventors. All rights reserved.
 */

#ifndef IMPCONTAINER_LIST_TRIPLET_CONTAINER_H
#define IMPCONTAINER_LIST_TRIPLET_CONTAINER_H

#include <IMP/container/container_config.h>
#include <IMP/base/object_macros.h>
#include <IMP/kernel/internal/StaticListContainer.h>
#include <IMP/kernel/TripletContainer.h>
#include <IMP/kernel/TripletModifier.h>
#include <IMP/kernel/base_types.h>

IMPCONTAINER_BEGIN_NAMESPACE

//! Store a kernel::ParticleIndexTriplets
/** \note The order may change when particles are inserted
    as the list is maintained in sorted order.

    \note Changing the contents of the container is a fairly heavy
    weight operation as it resets part of the dependency graph. Use
    a DynamicListTripletContainer if you want to change the contents
    frequently (eg via a kernel::ScoreState).
 */
class IMPCONTAINEREXPORT ListTripletContainer :
#if defined(IMP_DOXYGEN) || defined(SWIG)
    public TripletContainer
#else
    public IMP::kernel::internal::StaticListContainer<
        kernel::TripletContainer>
#endif
    {
  typedef IMP::kernel::internal::StaticListContainer<kernel::TripletContainer>
      P;

 public:
  ListTripletContainer(kernel::Model *m, const kernel::ParticleIndexTriplets &contents,
                         std::string name = "ListTripletContainer%1%");

  ListTripletContainer(const kernel::ParticleTripletsTemp &ps,
                         std::string name = "ListTripletContainer%1%");

  void set_particle_triplets(const kernel::ParticleTripletsTemp &ps);
  void set_particle_triplets(const kernel::ParticleIndexTriplets &contents);
#ifndef IMP_DOXYGEN
  ListTripletContainer(kernel::Model *m,
                         std::string name = "ListTripletContainer %1%");
  ListTripletContainer(kernel::Model *m, const char *name);

  void add_particle_triplet(const kernel::ParticleTriplet& vt);
  void add_particle_triplets(const kernel::ParticleTripletsTemp &c);
  void clear_particle_triplets();
#endif
#ifdef SWIG
  kernel::ParticleIndexTriplets get_indexes() const;
  kernel::ParticleIndexTriplets get_range_indexes() const;
  kernel::ModelObjectsTemp do_get_inputs() const;
  void do_apply(const TripletModifier *sm) const;
  kernel::ParticleIndexes get_all_possible_indexes() const;

 private:
  std::size_t do_get_contents_hash() const;
#endif
  IMP_OBJECT_METHODS(ListTripletContainer);
};

IMP_OBJECTS(ListTripletContainer, ListTripletContainers);

IMPCONTAINER_END_NAMESPACE

#endif /* IMPCONTAINER_LIST_TRIPLET_CONTAINER_H */
