/**
 *  \file IMP/container/MinimumQuadScore.h
 *  \brief Define QuadScore.
 *
 *  This file is generated by a script (tools/make-container).
 *  Do not edit directly.
 *
 *  Copyright 2007-2014 IMP Inventors. All rights reserved.
 */

#ifndef IMPCONTAINER_MINIMUM_QUAD_SCORE_H
#define IMPCONTAINER_MINIMUM_QUAD_SCORE_H

#include <IMP/container/container_config.h>
#include <IMP/QuadScore.h>
#include <IMP/quad_macros.h>

IMPCONTAINER_BEGIN_NAMESPACE

//! Evaluate the min or max n particle_quad scores of the passed set
/** Each of the set of QuadScores is evaluated and the sum of the
    minimum n is returned.
*/
class IMPCONTAINEREXPORT MinimumQuadScore : public QuadScore {
  QuadScores scores_;
  unsigned int n_;

 public:
  MinimumQuadScore(const QuadScoresTemp &scores, unsigned int n = 1,
                        std::string name = "QuadScore %1%");
  virtual double evaluate_index(kernel::Model *m, const kernel::ParticleIndexQuad& vt,
                                DerivativeAccumulator *da) const IMP_OVERRIDE;
  virtual kernel::ModelObjectsTemp do_get_inputs(
      kernel::Model *m, const kernel::ParticleIndexes &pis) const IMP_OVERRIDE;
  IMP_QUAD_SCORE_METHODS(MinimumQuadScore);
  IMP_OBJECT_METHODS(MinimumQuadScore);

  Restraints do_create_current_decomposition(kernel::Model *m,
                                             const kernel::ParticleIndexQuad& vt) const
      IMP_OVERRIDE;
};

IMP_OBJECTS(MinimumQuadScore, MinimumQuadScores);

IMPCONTAINER_END_NAMESPACE

#endif /* IMPCONTAINER_MINIMUM_QUAD_SCORE_H */
