/**
 *  \file IMP/container/PairContainerSet.h
 *  \brief Store a set of PairContainers
 *
 *  This file is generated by a script (tools/maintenance/make-container).
 *  Do not edit directly.
 *
 *  Copyright 2007-2014 IMP Inventors. All rights reserved.
 */

#ifndef IMPCONTAINER_PAIR_CONTAINER_SET_H
#define IMPCONTAINER_PAIR_CONTAINER_SET_H

#include <IMP/container/container_config.h>
#include <IMP/PairContainer.h>
#include <IMP/container_macros.h>
#include <IMP/kernel/internal/container_helpers.h>
#include <IMP/scoped.h>

IMPCONTAINER_BEGIN_NAMESPACE

//! Stores a set of PairContainers
/** The input sets must be disjoint. This can change if there is
    demand for it.

    \usesconstraint
*/
class IMPCONTAINEREXPORT PairContainerSet : public PairContainer {
  Ints versions_;
  static PairContainerSet *get_set(PairContainer *c) {
    return dynamic_cast<PairContainerSet *>(c);
  }
  virtual std::size_t do_get_contents_hash() const IMP_OVERRIDE;

 public:
  //! Construct and empty set
  PairContainerSet(kernel::Model *m,
                        std::string name = "PairContainerSet %1%");

  PairContainerSet(const PairContainersTemp &pc,
                        std::string name = "PairContainerSet %1%");

  /** \brief apply modifer sm to all pair containers */
  IMP_IMPLEMENT(void do_apply(const PairModifier *sm) const);

  template <class M>
  void apply_generic(const M *m) const {
    apply(m);
  }

  kernel::ParticleIndexes get_all_possible_indexes() const;
  IMP_OBJECT_METHODS(PairContainerSet);

  /** @name Methods to control the nested container

      This container merges a set of nested containers. To add
      or remove nested containers, use the methods below.
  */
  /**@{*/
  IMP_LIST_ACTION(public, PairContainer, PairContainers,
                  pair_container, pair_containers,
                  PairContainer *, PairContainers,
  {
    obj->set_was_used(true);
    versions_.clear();
  },
                  {}, );
/**@}*/

#ifndef IMP_DOXYGEN
  kernel::ParticleIndexPairs get_indexes() const;
  kernel::ParticleIndexPairs get_range_indexes() const;
  kernel::ModelObjectsTemp do_get_inputs() const;
#endif
};

IMPCONTAINER_END_NAMESPACE

#endif /* IMPCONTAINER_PAIR_CONTAINER_SET_H */
