/**
 *  \file IMP/kernel/SingletonModifier.h
 *  \brief A Modifier on kernel::ParticlesTemp
 *
 *  WARNING This file was generated from SingletonModifier.h
 *  in /builddir/build/BUILD/imp-2.2.0/imp/tools/build/container_templates/kernel
 *  by tools/maintenance/setup_containers.py.
 *
 *  Copyright 2007-2014 IMP Inventors. All rights reserved.
 */

#ifndef IMPKERNEL_SINGLETON_MODIFIER_H
#define IMPKERNEL_SINGLETON_MODIFIER_H

#include <IMP/kernel/kernel_config.h>
#include "DerivativeAccumulator.h"
#include "base_types.h"
#include "ParticleTuple.h"
#include "internal/container_helpers.h"
#include "model_object_helpers.h"

IMPKERNEL_BEGIN_NAMESPACE

//! A base class for modifiers of kernel::ParticlesTemp
/** The primary function of such a class is to change
    the passed particles.

    \see IMP::SingletonFunctor

    Implementors should see IMP_SINGLETON_MODIFIER(). Also see
    SingletonDerivativeModifier.
 */
class IMPKERNELEXPORT SingletonModifier : public ParticleInputs,
                                          public ParticleOutputs,
                                          public base::Object {
 public:
  typedef kernel::Particle* Argument;
  typedef kernel::ParticleIndex IndexArgument;
  SingletonModifier(std::string name = "SingletonModifier %1%");

  /** \deprecated_at{2.1} use the index version instead*/
  IMPKERNEL_DEPRECATED_METHOD_DECL(2.1)
  virtual void apply(kernel::Particle* vt) const;

  /** Apply the function to a single value*/
  virtual void apply_index(kernel::Model *m, kernel::ParticleIndex v) const;

  /** Apply the function to a collection of kernel::ParticlesTemp */
  /** If bounds are passed, only apply to ones between the upper and
      lower bounds.*/
  virtual void apply_indexes(kernel::Model *m, const kernel::ParticleIndexes &o,
                             unsigned int lower_bound,
                             unsigned int upper_bound) const {
    for (unsigned int i = lower_bound; i < upper_bound; ++i) {
      apply_index(m, o[i]);
    }
  }
};

IMPKERNEL_END_NAMESPACE

#endif /* IMPKERNEL_SINGLETON_MODIFIER_H */
