/**
 *  \file IMP/kernel/TripletModifier.h
 *  \brief A Modifier on kernel::ParticleTripletsTemp
 *
 *  WARNING This file was generated from TripletModifier.h
 *  in /builddir/build/BUILD/imp-2.2.0/imp/tools/build/container_templates/kernel
 *  by tools/maintenance/setup_containers.py.
 *
 *  Copyright 2007-2014 IMP Inventors. All rights reserved.
 */

#ifndef IMPKERNEL_TRIPLET_MODIFIER_H
#define IMPKERNEL_TRIPLET_MODIFIER_H

#include <IMP/kernel/kernel_config.h>
#include "DerivativeAccumulator.h"
#include "base_types.h"
#include "ParticleTuple.h"
#include "internal/container_helpers.h"
#include "model_object_helpers.h"

IMPKERNEL_BEGIN_NAMESPACE

//! A base class for modifiers of kernel::ParticleTripletsTemp
/** The primary function of such a class is to change
    the passed particles.

    \see IMP::TripletFunctor

    Implementors should see IMP_TRIPLET_MODIFIER(). Also see
    TripletDerivativeModifier.
 */
class IMPKERNELEXPORT TripletModifier : public ParticleInputs,
                                          public ParticleOutputs,
                                          public base::Object {
 public:
  typedef kernel::ParticleTriplet Argument;
  typedef kernel::ParticleIndexTriplet IndexArgument;
  TripletModifier(std::string name = "TripletModifier %1%");

  /** \deprecated_at{2.1} use the index version instead*/
  IMPKERNEL_DEPRECATED_METHOD_DECL(2.1)
  virtual void apply(const kernel::ParticleTriplet& vt) const;

  /** Apply the function to a single value*/
  virtual void apply_index(kernel::Model *m, const kernel::ParticleIndexTriplet& v) const;

  /** Apply the function to a collection of kernel::ParticleTripletsTemp */
  /** If bounds are passed, only apply to ones between the upper and
      lower bounds.*/
  virtual void apply_indexes(kernel::Model *m, const kernel::ParticleIndexTriplets &o,
                             unsigned int lower_bound,
                             unsigned int upper_bound) const {
    for (unsigned int i = lower_bound; i < upper_bound; ++i) {
      apply_index(m, o[i]);
    }
  }
};

IMPKERNEL_END_NAMESPACE

#endif /* IMPKERNEL_TRIPLET_MODIFIER_H */
